from typing import Protocol
import serial
class DeviceDriver(Protocol):
    serialDevice: serial.Serial
    waitTime: float
    def in_waiting(self) : return self.serialDevice.in_waiting
    def read(self,length) -> bytearray:
        pass
    def readByte(self) -> str:
        pass
    def writeByte(self,data: str):
        pass
    def listen(self):
        pass
    def connect(self) -> bool:
        pass
    def connectFinished(self):
        pass
    def hangup(self):
        pass
    def disconnect(self):
        pass
    def update(self):
        pass
    def answered(self):
        pass
    def netlinkAnswered(self):
        pass

    def device_status(self):
        pass