import time
import serial
from datetime import datetime
class SerialDriver:
    serialDevice: serial.Serial
    waitTime = 0.0

    def __init__(self, com_port: str):
           #110, 300, 1200, 2400, 4800, 9600, 19200, 38400, 57600, or 115200
    
        #(26874122 ) / (128 × (N + 1))
        N = 0
        n = 0
        cpu = 26874122 #26874122 # 28636363
        speed = round(cpu/((N+1) * 256 * pow(2,2 * n - 1)))
        speed =  115200 #209954 
        #print("Current speed:%s n%s N:%s" % (speed,n,N))
 
        self.serialDevice = serial.Serial(com_port,speed,timeout=0)
        
        
        
    def in_waiting(self) : return self.serialDevice.in_waiting
    def read(self,length ) -> bytearray:
        data = self.serialDevice.read(length)
        #char = data.strip().decode()
        if len(data) == 0:
            return None
        return data
        #self.serialDevice.open()
        #if not ser.isOpen():
        #    raise IOError("Serial unavailable!" )
        #ser.serialDevice.close()
    def readByte(self) -> bytearray:
        data = self.serialDevice.read()
        #char = data.strip().decode()
        if len(data) == 0:
            return None
        print("Data 0x%s %s" %  (format(ord(data), '02x') , data))
        return data
        
    def writeByte(self,data: str):
        self.serialDevice.write(data)

    def listen(self):
        pass
    def connect(self):
        try:
            self.serialDevice.in_waiting
            while(True):
                
                self.update()
                now = datetime.now()
                char = self.readByte()
                
             
                
                if not char or char != b'=':
                    continue
                
                self.connectFinished()
                print("Connect to Access Point finished")
                

                time_digit_heard = now
                while (datetime.now() - time_digit_heard).total_seconds() < self.waitTime:
                    continue;
            
                return self.serialDevice.is_open
        except IOError as error:
            return False
                
        
    def connectFinished(self):
        pass
    def hangup(self):
        pass
    def disconnect(self):
        pass
    def update(self):
        pass
    def answered(self):
        pass
    def netlinkAnswered(self):
        pass
    def device_status(self):
        print("parsing")
        while (True):
            data = self.readByte() #this is blocking, but the modem sends <DLE>s at regular intervals to indicate silence
            
            if not data: #which makes this pointless
                continue
            char = data.strip()
            if not char: #which makes this pointless
                continue
            char = char.decode()
            try:
                if char == '+':   
                    self.writeByte("O")
                    self.writeByte("K")
                if char == '*':   
                    print("# found")                
                    self.sendByte("*")
                    print("done parsing")
                    return True
            except (TypeError, ValueError):#Dreampi originally tried to convert characters to int and passed on the exception raised for other characters. This shouldn't be needed anymore.
                pass
                
        
        return False
    