import time
import socket
import select
from datetime import datetime
class TCPModemDriver:
    conn: socket.socket
    waitTime = 0.0
    udp: socket.socket
    tcp: socket.socket
    data: bytearray = b""
    
    def __init__(self):
        
        self.tcp = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.tcp.settimeout(1200)
        #tcp.bind(('', 1337))
        #tcp.listen(5)
 
        #global udp
        #udp = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        #udp.setblocking(0)
        #udp.bind(('', 1337))
    
    def in_waiting(self) -> int: 
        try:
            ready = select.select([self.tcp],[],[],0) #polling select
            if ready[0]:
                self.data += self.tcp.recv(1024)
        except Exception as error:
            print(error)
        finally:
            
            if self.data:
                return len(self.data) 
            return 0
        
    def read(self,length ) -> bytearray:
        subset = None
        try:
            waiting = self.in_waiting()
            if waiting > 0:
                if len(self.data) == 0:
                    return None
                subset = self.data[0:length]
                self.data = self.data[length:]
                #print("Data 0x%s %s" %  (format(ord(subset), '02x') , subset))
                
        except Exception as error:
            print("error")
        finally:
            return subset
            
            
    
        
    def readByte(self) -> bytearray:
    
        return self.read(1 )
        # ready = select.select([self.tcp],[],[],0) #polling select
        # if ready[0]:
            # self.data += self.tcp.recv(1)
            # if len(self.data) == 0:
                # return None
            # print("Data 0x%s %s" %  (format(ord(self.data), '02x') , self.data))
            # b = self.data[0:1]
            # self.data = self.data[1:]
            # return b
        # return None
        
    def writeByte(self,data: str):
       
        #conn.tcp(data)
        ready = select.select([],[self.tcp],[]) #blocking select  
        if ready[1]:
            self.tcp.send(data)
            
                                   
    def listen(self):
        pass
    def connect(self) -> bool:

        try:
            print("Connecting to host")
            self.tcp.connect(("127.0.0.1",1337))
            self.tcp.setblocking(0)
            while(True):
                ready = select.select([self.tcp], [], [],0)
                if not ready[0]:
                    continue;
                
       
                self.update()
                
                char = self.readByte()
                
                print(char)
                
                if not char or char != b'=':
                    continue
                now = datetime.now()
                self.connectFinished()
                print("Connect to Access Point finished")
                
                while(ready[0]):
                    ready = select.select([self.tcp], [], [],0)
                    if ready[0]:
                        self.readByte()
                        
    
                
                time_digit_heard = now
                while (datetime.now() - time_digit_heard).total_seconds() < self.waitTime:
                    continue;
                return True
        except IOError as error:
            self.tcp = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self.tcp.settimeout(1200)
            #print(IOError)
            return False   
        except:
            self.tcp = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self.tcp.settimeout(1200)
            #print(IOError)
            return False   
      
            
    def connectFinished(self):
        pass
    def hangup(self):
        pass
    def disconnect(self):
        self.tcp.close()
    def update(self):
        pass
    def answered(self):
        pass
    def netlinkAnswered(self):
        pass
    
    def device_status(self):
        print("parsing")
        while (True):
            data = self.readByte() #this is blocking, but the modem sends <DLE>s at regular intervals to indicate silence
            
            if not data: #which makes this pointless
                continue
            char = data.strip()
            if not char: #which makes this pointless
                continue
            char = char.decode()
            try:
                if char == '*':   
                    print("# found")                
                    self.sendByte("*")
                    print("done parsing")
                    return True
            except (TypeError, ValueError):#Dreampi originally tried to convert characters to int and passed on the exception raised for other characters. This shouldn't be needed anymore.
                pass
                
        
        return False
    