#tunnel_version=1663983944.323452

from Tunnel import Tunnel
import sys
import threading
import logging
import time
import requests
import platform
import socket
import serial

tunnel2 = Tunnel()
packetSplit = b"<packetSplit>"
dataSplit = b"<dataSplit>"

def listener():
    global tunnel2
    last = 0
    currentSequence = 0
    
    state = ""
    while(state != "netlink_disconnected"):
        
        packetSet = tunnel2.recvUDP()
        if packetSet:
            packets= packetSet.split(packetSplit)
            try:
                while True:
                    packetNum = 0
                    
                    #go through all packets 
                    for p in packets:
                      if int(p.split(dataSplit)[1]) == currentSequence:
                        break
                      packetNum += 1
                    
                    #if the packet needed is not here,  grab the latest in the set
                    if packetNum == len(packets):
                        packetNum = 0
                    
                    message = packets[packetNum]
                    payload = message.split(dataSplit)[0]
                    sequence = message.split(dataSplit)[1]
                    if int(sequence) < currentSequence:
                        break  #All packets are old data, so drop it entirely
                    
                    currentSequence = int(sequence) + 1
                    
                    toSend = payload
                    
                    print(toSend)
                    if packetNum == 0: # if the first packet was the processed packet,  no need to go through the rest
                        break

            except IndexError:
                continue
                      
           
def sender(oppPort):
    global tunnel2
    last = 0
    sequence = 0
    packets = []
    state = ""
    while(state != "netlink_disconnected"):
        
        raw_input = b'programClient 20001'
        if raw_input is None:
            continue
        if b"NO CARRIER" in raw_input:
            state = "netlink_disconnected"
            time.sleep(1)
            tunnel2.close()
            return
        
        try:
            payload = raw_input
            seq = str(sequence)
            if len(payload)>0:
                
                packets.insert(0,(payload+dataSplit+seq.encode()))
                if(len(packets) > 5):
                    packets.pop()
                #print("Port %d" % oppPort)
                tunnel2.sendUDP(packetSplit.join(packets),oppPort)            
                sequence+=1
        except:
            continue





        #deviceDriver.disconnect()
if __name__ == "__main__":
    print("Initializing tunnel connection")
    state = tunnel2.initConnection("127.0.0.1")
    print("Initialized")
    if state == "failed":
        print(state) 
        print("Hanging up")
        while(True):
            pass
    print("Checking Ack")      
    while not tunnel2.checkAcknowledge():
        pass
    print("Approved")
    
    tunnel2.ready()       
    tunnel2.establishUDPConnection(20002)
    print("Establish")
    t1 = threading.Thread(target=listener)
    print("Thread 1")
    t2 = threading.Thread(target=sender,args=[20001])
    print("Thread 2")
    
    t1.start()
    t2.start()
    t1.join()
    t2.join()
    while(True):
        pass
    
        