#tunnel_version=1663983944.323452

from Tunnel import Tunnel
import sys
import threading
import logging
import time
import requests
import platform
import socket
import serial

tunnel = Tunnel()
packetSplit = b"<packetSplit>"
dataSplit = b"<dataSplit>"
waiting2 = True

def listener():
    global tunnel
    last = 0
    currentSequence = 0
    
    state = ""
    while(state != "netlink_disconnected"):
        
        packetSet = tunnel.recvUDP()
        if packetSet:
            packets= packetSet.split(packetSplit)
            try:
                while True:
                    packetNum = 0
                    
                    #go through all packets 
                    for p in packets:
                      if int(p.split(dataSplit)[1]) == currentSequence:
                        break
                      packetNum += 1
                    
                    #if the packet needed is not here,  grab the latest in the set
                    if packetNum == len(packets):
                        packetNum = 0
                    
                    message = packets[packetNum]
                    payload = message.split(dataSplit)[0]
                    sequence = message.split(dataSplit)[1]
                    if int(sequence) < currentSequence:
                        break  #All packets are old data, so drop it entirely
                    
                    currentSequence = int(sequence) + 1
                    
                    toSend = payload
                    
                    print(toSend)
                    if packetNum == 0: # if the first packet was the processed packet,  no need to go through the rest
                        break

            except IndexError:
                continue
                      
            
def sender(oppPort):
    global tunnel
    last = 0
    sequence = 0
    packets = []
    state = ""
    while(state != "netlink_disconnected"):
        
        #raw_input = b'programServer 20002'
        raw_input = None
        if raw_input is None:
            continue
        if b"NO CARRIER" in raw_input:
            state = "netlink_disconnected"
            time.sleep(1)
            tunnel.close()
            return
        
        try:
            payload = raw_input
            seq = str(sequence)
            if len(payload)>0:
                
                packets.insert(0,(payload+dataSplit+seq.encode()))
                if(len(packets) > 5):
                    packets.pop()
                tunnel.sendUDP(packetSplit.join(packets),oppPort)            
                sequence+=1
        except:
            continue





        
def beginWaiting(): 
    global waiting2
    global tunnel
    tunnel.listening()
    while tunnel.accept() == False:
        continue;
        
    print("Accepted")
    
    tunnel.acknowledge()
    print("Waiting for Ready")
    while True:
        try:
            
            data = tunnel.messages()
        except socket.error: #first try can return no payload
            continue
           
        if data == b'readyip':
            print(data)
            tunnel.begin()
            
            print("TCP: Ring")
            waiting2 = False
    
            return 
        elif data:
            print('TCP: %s' % data)

    
    
       


        #deviceDriver.disconnect()
if __name__ == "__main__":
    
    waitThread = threading.Thread(target=beginWaiting, daemon=True)
    waitThread.start()
    while(waiting2):
        pass
    tunnel.establishUDPConnection(20001)
    print("Establish")
    t1 = threading.Thread(target=listener)
    print("Thread 1")
    t2 = threading.Thread(target=sender,args=[20002])
    print("Thread 2")

    t1.start()
    t2.start()
    t1.join()
    t2.join()


    while(True):
        pass
    
        